package com.agiledeveloper;

import java.util.ArrayList;

public class Example
{
    public static void main(String[] args)
    {
        ArrayList lst1 = new ArrayList();
        lst1.add(1);
        //lst1.add(1.0); // Will throw exception in the for loop
        lst1.add(2);

        int total1 = 0;

        for(Object val : lst1)
        {
            total1 += ((Integer)(val)).intValue();
        }

        System.out.println("Total=" + total1);

        // Using generics
        ArrayList<Integer> lst2 = new ArrayList<Integer>();
        lst2.add(1);
        //lst2.add(1.0); // Compilation error
        lst2.add(2);

        int total2 = 0;

        for(int val : lst2) // Ease of use here
        {
            total2 += val; // Much simpler than above
        }

        System.out.println("Total=" + total2);

        // A Gotcha. Uncomment the following statement and run.
        //foo(lst2);

        for (int val : lst2) // Ease of use here
        {
            total2 += val; // Much simpler than above
        }
    }

    public static void foo(ArrayList lst)
    {
        lst.add(2.0);
    }
}